% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/genpres.R
\name{genpresEVhet}
\alias{genpresEVhet}
\title{generate expected value detection histories for model with heterogeneous detections}
\usage{
genpresEVhet(
  N = 100,
  K = 4,
  psi = 0.75,
  p = c(0.4, 0.8),
  eps = 0,
  gam = 0,
  pi = 0.3,
  SPS = 0,
  opt = 0
)
}
\arguments{
\item{N}{number of sites}

\item{K}{number of surveys}

\item{psi}{probability of occupancy}

\item{p}{probability of detection for each group}

\item{eps}{probability of local extinction between seasons}

\item{gam}{probability of local colonization between seasons}

\item{SPS}{number of surveys per season}

\item{opt}{option to restrict assignment of group membership to initial season}
}
\value{
list(hst=det. history matrix, frq=vector of frequencies)
}
\description{
\code{genpresEV} generates expected value detection history frequencies for
single or multi-season heterogeneity models
}
\note{
This function generates at least 2^K detection-histories, so if K>8,
       it may take a very long time to run.
       The "opt" argument controls how sites are assigned to the 2 groups.
       By default (opt=0), sites can change groups each season, even if
       the "pi" parameter is constant over seasons.  If opt=1, sites
       remain in the same group over all seasons.
}
\seealso{
\code{\link{genpresEVms}},\code{\link{genpresSD}},
         \code{\link{genpresSDms}}
}
