#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "SingAnal.h"

void TwoSpCorrDet(int NBoot, char *s, int NPar, double *Params){ 

    double TwoSpCorrDetLink(double *Params, int NPar);
	int try_optmz_randiv(double (*LinkFn)(double *Params, int npar), int NPar, double *Params, double *Work, double *Hess, double *MaxLL);
    void print_individual_estimates2(FILE *g, int parmnum, int pgrp, int istrt, int nrealparms, double **covar, double *Params, int linkfn, int fsite, int nsites);
    void prntBetas(double xxLike(double *p, int N), int NPar, double *Params, double *Work, double MaxLL, double **covar);
	void DoAmoeba( double *Params, int NPar, double (*funk)(double [], int), double xincr);	

    int i,j,ii, jj, N=SingSpec.N, T=SingSpec.T, site, survey, season=0, PrmyPeriods=SingSpec.PrmyPeriods;
	double *Hess, *Grad, *Work, MaxLL, **covar, *naiveA, *naiveB, dA=0, dB=0, totsites=0; FILE *g;
	naiveA=new double[PrmyPeriods+1]; naiveB=new double[PrmyPeriods+1];

    g=SingSpec.g;
    fprintf(g,"Two Species Corr. Detections, Single Season Model:\n---------------------------------\n");
    if (strstr(SingSpec.Realname[0][2],"psiBa")>(void*)NULL || strstr(SingSpec.Realname[0][2],"psiB2")>(void*)NULL) {
        SingSpec.Alt_Param_Checked=1;
        fprintf(g,"-- alternate parameterization requested: psiA,psiBA,psiBa,pA,pB,rA,rBA,rBa\n");
    }
    else 
        if (strstr(SingSpec.Realname[0][2],"nu")>(void*)NULL) {
            SingSpec.Alt_Param_Checked=2;
            fprintf(g,"-- alternate parameterization requested: psiA,psiBa,nu,pA,pB,rA,rBa,rho\n");
        }
        else {
            SingSpec.Alt_Param_Checked=0;
            fprintf(g,"-- standard parameterization requested: psiA,psiB,phi,pA,pB,rA,rB,delta\n");
        }
    if (SingSpec.Nstates==2) {   //  if data only contains 0's and 1's... then stacked input!
        N/=2; N/=2; SingSpec.NMiss/=2; 
        fprintf(g,"-- stacked input: 1st %d records=species A, last %d records=species B\n",N,N);
		for (site=0; site<N; site++) {
			for (season=j=0; season<PrmyPeriods; season++) {
				for (survey=dA=dB=0; survey<SingSpec.SecPeriods[season]; survey++,j++) {                              //  combined codes:  1=det of A only
					if (SingSpec.Data[site][j]>0) dA=SingSpec.det_hist_frq[site];
					if (SingSpec.Data[N+site][j]>0) dB=SingSpec.det_hist_frq[site];
					if (SingSpec.Data[site][j]>=0) {                           //                  2=det of B only
						if (SingSpec.Data[N+site][j]>=0)                        //                 3=det of  A & B  
							SingSpec.Data[site][j]=SingSpec.Data[site][j]+2*SingSpec.Data[N+site][j];
						else                                                              //              4=no det of A, B not sampled(missing)
							SingSpec.Data[site][j]+=4; //  A not det or det, B missing              5=det of A, B not sampled(missing)
					}                                                                      //             6=no det of B, A not sampled     
					else {   //  species A missing...                                                     7=det of B, A not sampled
						if (SingSpec.Data[N+site][j]>=0) 
							SingSpec.Data[site][j]=SingSpec.Data[N+site][j]+6;       //        -1=Neither A or B sampled
						else
							SingSpec.Data[site][j]=-1; //  both A and B missing					
					}
				}
				naiveA[season]+=dA; naiveB[season]+=dB;
			}
		}
    }
    else  {
		fprintf(g,"-- compressed input detected: 1=species A, 2=species B, 3=both\n");
		for (totsites=site=0; site<N; site++) {        //  compute naive occupancy for each species...
			totsites+=SingSpec.det_hist_frq[site];
			for (season=j=0; season<PrmyPeriods; season++) {
				for (survey=dA=dB=0; survey<SingSpec.SecPeriods[season]; survey++) {   
					i=SingSpec.Data[site][j++];
					if (i==1 || i==3 || i==5) dA=SingSpec.det_hist_frq[site];
					if (i==2 || i==3 || i==7) dB=SingSpec.det_hist_frq[site];
				}
				naiveA[season]+=dA; naiveB[season]+=dB;
			}
		}
	}

    fprintf(g,"\n%d Primary periods\n  Secondary periods:",PrmyPeriods);
    if (PrmyPeriods<1) {
        fprintf(g,"\nError: invalid number of primary periods (%d)\n",PrmyPeriods);
        exit(1);
    }
    for (ii=0; ii<PrmyPeriods; ii++) {
        fprintf(g," %d",SingSpec.SecPeriods[ii]);
        if (SingSpec.SecPeriods[ii]<1) {
            fprintf(g,"\nError: invalid number of secondary periods (%d)\n",SingSpec.SecPeriods[ii]);
            exit(1);
        }
    }

    fprintf(g,"\n\nNumber of input rows           = %d\n", N);
    fprintf(g,"Number of sites                = %4.0f\n", totsites);
    fprintf(g,"Number of sampling occasions   = %d\n", T);
    fprintf(g,"Number of missing observations = %d\n\n", SingSpec.NMiss);

	fprintf(g,"Naive occupancy for species A:");
	for (season=0; season<PrmyPeriods; season++) fprintf(g," %8.4f",naiveA[season]/totsites);
	fprintf(g,"\nNaive occupancy for species B:"); 
	for (season=0; season<PrmyPeriods; season++) fprintf(g," %8.4f",naiveB[season]/totsites);
	delete [] naiveA; delete [] naiveB;
        
    // try amoeba routine to get starting values
    
    fprintf(g,"\nModel:%s NPar=%d s=%s\n",SingSpec.modname,NPar,s);

    if (SingSpec.UseAmoeba) DoAmoeba(Params, NPar, TwoSpCorrDetLink, 1.0);
    Hess = new double[NPar*(NPar+1)/2+2]; Work = new double[3*NPar+2]; Grad = new double[NPar+2];
    covar = new double*[NPar]; for (ii=0; ii<NPar; ii++) covar[ii]=new double[NPar];

    ii=try_optmz_randiv(TwoSpCorrDetLink, NPar, Params, Work, Hess, &MaxLL);   
	
	if (SingSpec.Verbose>1) {
		printf("optimize done... maxll=%f\n",MaxLL);
		for (ii=0; ii<SingSpec.N; ii++) {
	      for (jj=0; jj<SingSpec.T; jj++) fprintf(g,"%d",SingSpec.Data[ii][jj]);
	      fprintf(g," %12.6f %12.6f %12.6f\n",SingSpec.det_hist_frq[ii],SingSpec.expval[ii],SingSpec.det_hist_frq[ii]-SingSpec.expval[ii]);
	    }
	}
    // output results
    prntBetas(TwoSpCorrDetLink,NPar, Params, Work, MaxLL, covar);
    
    //   call link function to print re-parameterized estimates
    //SingSpec.ifn=-2; fx=TwoSpeciesLink(Params,NPar);
    
    //  print_individual_estimates(FILE *g, char *lbl, int pgrp, int istrt, int nrealparms, double **covar, double *Params, int linkfn);
    fprintf(g,"\n============================================================\n");
    print_individual_estimates2(g,0,0,0,1,covar,Params,SingSpec.LinkFn,0,0); // PsiA
    print_individual_estimates2(g,1,0,1,1,covar,Params,SingSpec.LinkFn,0,0);  // psiBA
    print_individual_estimates2(g,2,0,2,1,covar,Params,SingSpec.LinkFn,0,0); // psiBa
    
    print_individual_estimates2(g,3,0,3,T,covar,Params,SingSpec.LinkFn,0,0); // thetaA
    print_individual_estimates2(g,3+T,0,3+T,T,covar,Params,SingSpec.LinkFn,0,0); // thetaA'
    print_individual_estimates2(g,3+2*T,0,3+2*T,T,covar,Params,SingSpec.LinkFn,0,0);  // thetaBA
    print_individual_estimates2(g,3+3*T,0,3+3*T,T,covar,Params,SingSpec.LinkFn,0,0);  // thetaBA'
    print_individual_estimates2(g,3+4*T,0,3+4*T,T,covar,Params,SingSpec.LinkFn,0,0);  // thetaBa
    print_individual_estimates2(g,3+5*T,0,3+5*T,T,covar,Params,SingSpec.LinkFn,0,0);  // thetaBa'
    
    print_individual_estimates2(g,3+6*T,1,0,T,covar,Params,SingSpec.LinkFn,0,0);  // pA
    print_individual_estimates2(g,3+7*T,1,T,T,covar,Params,SingSpec.LinkFn,0,0);   // pB
    print_individual_estimates2(g,3+8*T,1,2*T,T,covar,Params,SingSpec.LinkFn,0,0);  // rA
    print_individual_estimates2(g,3+9*+T,1,3*T,T,covar,Params,SingSpec.LinkFn,0,0);
    print_individual_estimates2(g,3+10*T,1,4*T,T,covar,Params,SingSpec.LinkFn,0,0); // rBa
    
    print_individual_estimates2(g,3+11*T,2,0,3,covar,Params,SingSpec.LinkFn,0,0); // th0pi
    // delete dynamic variables
    
    for (ii=0; ii<NPar; ii++) delete[] covar[ii];  
	delete[] Hess; delete[] Work; delete[] Grad; delete[] covar;
}
