#
library(RPresence); #setwd('c:/tmp')

d1=genpresEV(K=3, p=.4, fp=.1, psi=.7)
pao=createPao(data=d1$hst, frq=d1$frq)
fixed=data.frame(param=paste0("b(",1:3,")"), value=rep(0,3))
m1=occMod(list(psi~1, p11~1, p10~1, b~1),
          data=pao, type="so.fp", fixed=fixed)

expect_equal(round(m1$real$psi$est[1],2),0.7)
expect_equal(round(m1$real$p11$est[1],2),0.4)
expect_equal(round(m1$real$p10$est[1],2),0.1)

# --- FALSE-POSITIVE MODEL WITH EXPECTED-VALUE DATA ----\n')

hstfrq=genpresEV(N=1000, K=4, psi=.8, p=.3, fp=0.1, b=0.5)  #  generate expected-value data...
EVpao=createPao(hstfrq$hst,frq=hstfrq$frq)                  #  create pao file
EVmod1<-occMod(model=list(psi~1,p11~1,p10~1,b~1),data=EVpao,type="so.fp")  # generate results
#  compare specified input parameters with estimated parameters...
reslt=cbind(c(.8,.3,.1,.5),c(EVmod1$real$psi$est[1],EVmod1$real$p11$est[1],EVmod1$real$p10$est[1],EVmod1$real$b$est[1]))
rownames(reslt)=c('psi','p11','p10','b'); colnames(reslt)=c('input_parameter','estimated_parameter')
x=print_one_site_estimates(EVmod1)

# -- FALSE-POSITIVE MODEL WITH EXPECTED-VALUE DATA ---
expect_equal(round(EVmod1$aic,3),6017.259)
expect_equal(round(EVmod1$real$psi$est[1],4),0.8)
expect_equal(round(EVmod1$real$p11$est[1],4),0.3)
expect_equal(round(EVmod1$real$p10$est[1],4),0.1)
expect_equal(round(EVmod1$real$b$est[1],4),0.5)
